<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { CtfButton } from '../../models/content-types.dto';

interface LearnMoreCard {
  type: string;
  icon: string;
  title: string;
  href: string;
  primaryButton?: CtfButton;
  secondaryButton?: CtfButton;
  additionalButtons?: CtfButton[];
}
export default Vue.extend({
  props: {
    header: {
      type: String,
      required: false,
      default: '',
    },
    cards: {
      type: Array as PropType<LearnMoreCard[]>,
      required: true,
    },
  },
});
</script>

<template>
  <div class="learn-more">
    <SlpTypography variant="heading3-bold">{{ header }}</SlpTypography>
    <div class="card-container">
      <div v-for="card in cards" :key="card.title" class="card">
        <div class="type">
          <SlpIcon
            :name="card.icon"
            variant="marketing"
            size="md"
            class="card__icon"
          />
          <SlpTypography variant="body2">{{ card.type }}</SlpTypography>
        </div>
        <SlpTypography variant="heading4-bold" tag="h4" class="title">{{
          card.title
        }}</SlpTypography>
        <div class="slp-mt-32 slp-mt-md-96">
          <SlpButton
            v-if="card.primaryButton"
            variant="tertiary"
            :href="card.primaryButton.externalUrl"
            :data-ga-name="
              card.primaryButton.dataGaName || card.primaryButton.text
            "
            :data-ga-location="
              card.primaryButton.dataGaLocation || 'learn-more'
            "
            >{{ card.primaryButton.text }}
            <SlpIcon
              :name="card.primaryButton.iconName || 'chevron-right'"
              :variant="card.primaryButton.iconVariant || 'product'"
              class="slp-ml-16"
          /></SlpButton>
          <SlpButton
            v-if="card.secondaryButton"
            variant="tertiary"
            :data-ga-name="
              card.secondaryButton.dataGaName || card.secondaryButton.text
            "
            :data-ga-location="
              card.secondaryButton.dataGaLocation || 'learn-more'
            "
            :href="card.secondaryButton.externalUrl"
            >{{ card.secondaryButton.text }}
            <SlpIcon
              :name="card.secondaryButton.iconName || 'chevron-right'"
              :variant="card.secondaryButton.iconVariant || 'product'"
              class="slp-ml-16"
          /></SlpButton>
          <SlpButton
            v-for="button in card.additionalButtons"
            :key="button.text"
            variant="tertiary"
            :href="button.externalUrl"
            :data-ga-name="button.dataGaName || button.text"
            :data-ga-location="button.dataGaLocation || 'learn-more'"
            >{{ button.text }}
            <SlpIcon
              :name="button.iconName || 'chevron-right'"
              :variant="button.iconVariant || 'product'"
              class="slp-ml-16"
          /></SlpButton>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.learn-more {
  padding: 96px 0;
}
.card-container {
  display: grid;
  grid-template-columns: 1fr;
  gap: 16px;
  margin-top: 32px;
  @media (min-width: $breakpoint-lg) {
    grid-template-columns: 1fr 1fr 1fr;
  }
  & > :nth-child(1),
  & > :nth-child(2) {
    .slp-btn.slp-btn-tertiary {
      &:before {
        content: '';
        height: 100%;
        width: 100%;
        position: absolute;
        left: 0;
        top: 0;
      }
    }
  }
  & > :nth-child(3) {
    &:hover {
      border-radius: 4px !important;
      background: #fff !important;
      cursor: default;
    }
  }
  .card {
    display: flex;
    padding: 32px;
    flex-direction: column;
    align-items: flex-start;
    transition: all 0.3s ease-in;
    cursor: pointer;
    color: $color-text-300;
    border: 1px solid $color-surface-300;
    border-radius: 4px;
    position: relative;
    .title {
      flex-basis: 100%;
      margin-top: 16px;
    }
    .type {
      display: flex;
      flex-direction: row;
      align-items: center;
      gap: 16px;
    }
    &:hover {
      border-radius: 4px 4px 82px 4px;
      background: #f5f2fd;
    }
    &__icon {
      height: 24px;
      width: 24px;
    }
  }
}
</style>
